<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Untitled Document</title>
</head>

<body>
<?php
// Starting a session
$params = array(
	'trace' => 1,
	'soap_version' => SOAP_1_1);
$BHClient = new SoapClient("https://api.bullhornstaffing.com/webservices-1.1/?wsdl",$params);

$username = "xxxxxx"; // replace with your username
$password = "xxxxxx"; // replace with your password
$apiKey = "xxxxxxx"; // replace with your apiKey

$session_request = new stdClass(); 
$session_request->username = $username; 
$session_request->password = $password;
$session_request->apiKey = $apiKey;
$API_session = $BHClient->startSession($session_request);
$API_currentSession = $API_session->return; 


// Creating a candidate
$address_array = array(
	'address1' => '1234 Fictional Street',
	'city' => 'Boulder',
	'state' => 'CO',
	'zip' => '12345',
	'countryID' => '1'
);

/* To make the username unique, use the first initial and last name with a random number. You can use any mechanism for generating the random number. */
	$random_num = rand(1000,9999);
	$username = 'bjennings'.$random_num;

$candidate_array = array(
	'firstName' => 'Brett',
	'lastName' => 'Jennings',
	'name' => 'Brett Jennings',
	'phone' => '505-555-5555',
	'email' => 'bj@test.com',
	'address' => $address_array,
	'username' => $username,
	'status' => 'Available',
	'description' => 'This is where the text of the resume goes.',
	'ownerID' => $API_currentSession->userId,
	'userTypeID' => 35,
	'categoryID' => 45,
	'password' => 'password'
);

$SOAP_dto = new SoapVar($candidate_array, SOAP_ENC_OBJECT, "candidateDto", "http://candidate.entity.bullhorn.com/");

$request_array = array(
	'session' => $API_currentSession,
	'dto' => $SOAP_dto
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "save", "http://save.apiservice.bullhorn.com/");

try{
	$saveResponse = $BHClient->save($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $saveResponse->return->session;
$savedCandidate = $saveResponse->return->dto;

//Adding work history

$workHistory_array = array(
	'candidateID' => $savedCandidate->userID,
	'title' => 'Architect',
	'comments' => 'Worked at Avaya until 2009.',
	'startDate' => new SoapVar('2008-01-01', XSD_DATE, "date", "http://www.w3.org/2001/XMLSchema"),
	'endDate' => new SoapVar('2009-12-31', XSD_DATE, "date", "http://www.w3.org/2001/XMLSchema"),
	'companyName' => 'Avaya'
);

$SOAP_workHistory = new SoapVar($workHistory_array, SOAP_ENC_OBJECT, "candidateWorkHistoryDto", "http://candidate.entity.bullhorn.com/");

$request_array = array(
	'session' => $API_currentSession,
	'dto' => $SOAP_workHistory
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "save", "http://save.apiservice.bullhorn.com/");

try{
	$saveResponse = $BHClient->save($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->__getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $saveResponse->return->session;
$savedCandidateWorkHistory = $saveResponse->return->dto;


// Adding candidate education
$education_array = array(
	'candidateID' => $savedCandidate->userID,
	'state' => 'CO',
	'school' => 'Colorado University',
	'degree' => 'MS',
	'major' => 'Computer Science',
	'graduationDate' => new SoapVar('2004-06-12', XSD_DATE, "date", "http://www.w3.org/2001/XMLSchema")
);

$SOAP_education = new SoapVar($education_array, SOAP_ENC_OBJECT, "candidateEducationDto", "http://candidate.entity.bullhorn.com/");

$request_array = array(
	'session' => $API_currentSession,
	'dto' => $SOAP_education
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "save", "http://save.apiservice.bullhorn.com/");

try{
	$saveResponse = $BHClient->save($SOAP_request);
} catch (SoapFault $fault) {
	var_dump($BHClient->_getLastRequest());
	die($fault->faultstring);
}

$API_currentSession = $saveResponse->return->session;
$savedCandidatEducation = $saveResponse->return->dto;



// Associating a category
$query_array = array( 
	'entityName' => 'Category',
	'maxResults' => 10,
	'where' => 'enabled = 1',
	'parameters' => array() 
);

$SOAP_query = new SoapVar($query_array, SOAP_ENC_OBJECT, "dtoQuery", "http://query.apiservice.bullhorn.com/");

$request_array = array (
	'session' => $API_currentSession,
	'query' => $SOAP_query
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "query", "http://query.apiservice.bullhorn.com/");

try{
	$queryResult = $BHClient->query($SOAP_request);
	} catch (SoapFault $fault) {
		echo $BHclient->__getLastResult();
	die($fault->faultstring);
}

$API_currentSession = $queryResult->return->session;

foreach ($queryResult->return->ids as $value){
	$findId = new SoapVar($value, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema");
	$find_request = array (
		'session' => $API_currentSession,
		'entityName' => 'Category',
		'id' => $findId
	);

	try{
		$findResult = $BHClient->find($find_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}

		$API_currentSession = $findResult->return->session;
		$foundCategory = $findResult->return->dto;
				
		echo('Found category using find(): '.$foundCategory->categoryID.' - '.$foundCategory->occupation.'<br>');

}
$category_array = array(
	'session' => $API_currentSession,
	'entityName' => 'Candidate',
	'id' => new SoapVar($savedCandidate->userID, XSD_INT, "int", "http://www.w3.org/2001/XMLSchema"), 
	'associationName' => 'categories',
	'associateId' => new SoapVar(254969, XSD_INT, "int", "http://www.w3.org/2001/XMLSchema")
);

$SOAP_request_associate = new SoapVar($category_array, SOAP_ENC_OBJECT, "associate", "http://associate.apiservice.bullhorn.com/");

try{
	$associateResponse = $BHClient->associate($SOAP_request_associate);
	} catch (SoapFault $fault) {
		echo $BHclient->__getLastResult();
	die($fault->faultstring);
}

$API_currentSession = $associateResponse->return->session;

// Associating skills

$skills_array = array(
	'session' => $API_currentSession,
	'entityName' => 'Candidate',
	'id' => new SoapVar($savedCandidate->userID, XSD_INT, "int", "http://www.w3.org/2001/XMLSchema"), 
	'associationName' => 'primarySkills',
	'associateId' => new SoapVar(121052, XSD_INT, "int", "http://www.w3.org/2001/XMLSchema")
);

$SOAP_request_associate = new SoapVar($skills_array, SOAP_ENC_OBJECT, "associate", "http://associate.apiservice.bullhorn.com/");

try{
	$associateResponse = $BHClient->associate($SOAP_request_associate);
	} catch (SoapFault $fault) {
		echo $BHclient->__getLastResult();
	die($fault->faultstring);
}

$API_currentSession = $associateResponse->return->session;

// Updating candidates

$query_array = array( 
	'entityName' => 'Candidate',
	'maxResults' => 10,
	'where' => "name = 'Brett Jennings'",
	'parameters' => array() 
);

$SOAP_query = new SoapVar($query_array, SOAP_ENC_OBJECT, "dtoQuery", "http://query.apiservice.bullhorn.com/");

$request_array = array (
	'session' => $API_currentSession,
	'query' => $SOAP_query
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "query", "http://query.apiservice.bullhorn.com/");

try{
	$queryResult = $BHClient->query($SOAP_request);
	$API_currentSession = $queryResult->return->session;
	} catch (SoapFault $fault) {
		echo $BHclient->__getLastResult();
	die($fault->faultstring);
}

foreach ($queryResult->return->ids as $value){
	$findId = new SoapVar($value, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema");
	$find_request = array (
		'session' => $API_currentSession,
		'entityName' => 'Candidate',
		'id' => $findId
	);

	try{
		$findResult = $BHClient->find($find_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}

		$API_currentSession = $findResult->return->session;

//change their phone number
		$thisCandidate = $findResult->return->dto;
		$thisCandidate->phone = '408-111-1111';

//save them back
$SOAP_thisCandidate = new SoapVar($thisCandidate, SOAP_ENC_OBJECT, "candidateDto", "http://candidate.entity.bullhorn.com/");

$request_array = array(
	'session' => $API_currentSession,
	'dto' => $SOAP_thisCandidate
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "save", "http://save.apiservice.bullhorn.com/");

	try{
		$saveResult = $BHClient->save($SOAP_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}
	
	$API_currentSession = $saveResult->return->session;
}

// Deleting candidates

$query_array = array( 
	'entityName' => 'Candidate',
	'maxResults' => 10,
	'where' => "name = 'Brett Jennings'",
	'parameters' => array() 
);

$SOAP_query = new SoapVar($query_array, SOAP_ENC_OBJECT, "dtoQuery", "http://query.apiservice.bullhorn.com/");

$request_array = array (
	'session' => $API_currentSession,
	'query' => $SOAP_query
);

$SOAP_request = new SoapVar($request_array, SOAP_ENC_OBJECT, "query", "http://query.apiservice.bullhorn.com/");

try{
	$queryResult = $BHClient->query($SOAP_request);
	$API_currentSession = $queryResult->return->session;
	} catch (SoapFault $fault) {
		echo $BHclient->__getLastResult();
	die($fault->faultstring);
}

$API_currentSession = $queryResult->return->session;

foreach ($queryResult->return->ids as $value){
	$findId = new SoapVar($value, XSD_INTEGER, "int","http://www.w3.org/2001/XMLSchema");
	$find_request = array (
		'session' => $API_currentSession,
		'entityName' => 'Candidate',
		'id' => $findId
	);

	try{
		$findResult = $BHClient->find($find_request);
		}catch (SoapFault $fault) {
			echo $BHclient->__getLastResult();
			die($fault->faultstring);
	}

		$API_currentSession = $findResult->return->session;

//Set the isDeleted property to true
		$thisCandidate = $findResult->return->dto;
		$thisCandidate->isDeleted = 'true';

/* To actually delete the candidate, you would pass thisCandidate to the save() operation. 
This step has been omitted in this case. */
}

?>
</body>
</html>
